=== debian/changelog ===
warsow (2.10-1mx150+1) mx; urgency=medium

  * Repackaged for MX 15.

 -- Mike Purtell <mandbx@sbcglobal.net>  Thu, 23 Jun 2016 19:06:48 -0700

warsow (2.10-1~getdeb1) xenial; urgency=medium

  * New upstream version

 -- Christoph Korn <christoph.korn@getdeb.net>  Thu, 28 Apr 2016 19:45:51 +0200

warsow (2.01-1~getdeb1) trusty; urgency=medium

  * New upstream version

 -- Christoph Korn <christoph.korn@getdeb.net>  Sat, 19 Dec 2015 18:04:57 +0100

warsow (2.0-1~getdeb1) trusty; urgency=medium

  * New upstream version
    General:
    + Switched to Creative Commons license for media assets.
    + Added full out-of-the-box gamepad support (XInput on Windows, SDL on
    Linux and OS X).
    + The engine automatically lowers the frame rate to 24 FPS and enables
    sleep state when the game is minimized.
    + Multi-threading improvements for the following; fixed race conditions,
    reduced latency and the amount of context switches.
    + .pk3 files explicitly named as "pure" are now preferred to different
    .pk3 files.
    + Restricted downloads of binary modules and "pure" content to official
    Warsow web mirror.
    + Greatly reduced memory footprint for fonts (especially for CJK).
    + Pressing Escape key during the map load or connection set-up will now
    cancel the process much quicker.
    + New high resolution "flat" icon.
    + Maximum refresh rate now defaults to 250 fps.
    + It is now possible to pause demo playback at the end of a demo file,
    instead of dropping to main menu (see "demo" command help).
    + Added "flipped view" mode, set "cl_flip" to "1" to enable.
    + Use HTTPS for secure authentication to matchmaker.

    Renderer:
    + 30% to 50% overall performance improvement.
    + Greatly reduced VRAM footprint for textures.
    + Added support for texture arrays, used for lightmaps.
    + Added KTX texture format support.
    + Enabled binary cache for GLSL programs to speed up startup time by
    default now.
    + Enabled multi-threading to speed up map loading by default now.
    + Curved meshes are now optimized to remove excessive polygons.
    + Changed rendering order so that the sky is now rendered after world
    geometry to minimize overdraw.
    + Fixed infinite far clipping plane calculations.
    + The renderer now queries the operating system for available screen
    resolutions.
    + Shadowmaps now account for normals of geometry they are cast on, making
    them less prone to be visible through walls and ceilings.
    + Added "stencilTest" shader keyword.
    + Added per map colour correction support. Toggle-able with
    cg_colorCorrection 0/1, maps can define colorCorrection <file path> key
    in worldspawn to use color correction profile.
    - Removed "vid_mode", "vid_customwidth" and "vid_customheight" console
    variables in favour of "vid_width" and "vid_height" for video
    modesetting.
    - Dropped support for "noDepthTest" shader keyword.
    - Dropped "r_colorbits" console variable (used to set desktop colour
    depth).

    Gameplay:
    + New Tutorial game mode.
    + Added 3 new awards:
    ++ First Frag (awarded to the first fragger);
    ++ Fair Play (say "gg" to your opponents during the post-match using the
    chat or the vsay);
    ++ Man of the Match (You must score the most + achieve the ""Fair Play"
    award). -See above-.
    + Added sounds for Lasergun, Electrobolt and Instagun impacts.
    + New spawn points selection algorithm: returns the furthest point to
    which there's less than 4 points on the map; otherwise it returns to a
    random one, excluding the closest 3 points.
    + Ammo packs dropped on a players deaths, now actually contain strong
    ammo.
    + The movement style now defaults to "old movement", set
    "cg_movementStyle" to "1" for "new movement".
    + Incorporated a number of movement fixes from Racesow.
    + Ranked servers will now announce a players profile name at warsow.net
    alongside the nickname of the players entrance to the server.
    + On ranked servers, the "players" command now also prints login names
    for authenticated players.
    + After joining a server, the game menu is now opened automatically.
    + On ranked servers, certain votes now require players to be
    authenticated.
    + Votes now ignore AFK players.
    + In round-based game modes, in-active players are not removed until the
    beginning of the next round.
    + Added bot navigation files for wda5 and wbomb6.
    + Player movement prediction now works properly when riding a moving
    platform.
    + New RL/GL trail effect, cg_rocketTrail & cg_grenaderTrail merged into
    cg_projectileTrail.
    + Bots will now ignore chatting players.
    + Reduced respawn sound volume by 35%.
    + Added new callvote options "shuffle" and "rebalance".
    + Decreased weapon respawn timer to 10 in Duel.
    + In bomb, players can now move at crouch speed during the pre-round;
    upped maximum running speed to 320ups.
    - Removed 'Team Domination' game mode.

    Graphics:
    + New "illuminati" gibs.
    + New Instagun & Electrobolt decals.
    + New "simple items" sprites.
    + New teleportation\spawn effect.
    + New EB beam texture for cg_ebbeam_old 1.
    + New default EB beam effect.
    + New Lasergun beam, added hit model for LG endpoint.
    + New bullet hit decal and model.
    + Improved rocket launcher projectile texture.
    + Added gloss textures for BigVic and Bobot player models.
    + Added cg_viewBob, viewport smoothing/bobbing to falling/high jumps.
    + Bomb model colour follows the planted state dynamic light color (red
    when planted, orange normally).
    + Disabling gun "bobbing" now also disables fire and idle gun animations.
    + New damage hit effect (cg_showBloodTrail).

    Weapons:
    + Reduced Rocket Launcher pick-up ammo count to 5.
    + Reduced Lasergun and Plasmagun pick-up ammo count to 50.
    + Increased Lasergun and Plasmagun ammo box count to 100.

