=== debian/control ===
Source: warsow
Section: games
Priority: optional
Maintainer: Mike Purtell (mmikeinsantarosa) <maintainer@mepiscommunity.org>
XSBC-Original-Maintainer: GetDeb Package Ninjas <package.ninjas@getdeb.net>
Uploaders: Gonéri Le Bouder <goneri@rulezlan.org>, Bruno "Fuddl" Kleinert <fuddl@gmx.de>, Andres Mejia <mcitadel@gmail.com>
Build-Depends: debhelper (>= 9),
               cmake,
               tofrodos,
               sharutils,
               libopenal-dev,
               libjpeg-dev,
               libxrandr-dev,
               libvorbis-dev,
               libsdl2-dev,
               libz-dev,
               libxxf86vm-dev,
               libxxf86dga-dev,
               libxinerama-dev,
               libcurl4-gnutls-dev | libcurl3-gnutls-dev,
               libfreetype6-dev,
               libtheora-dev,
               libxi-dev
Standards-Version: 3.9.7
Homepage: https://www.warsow.gg/

Package: warsow
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         warsow-data (>= 2.10)
Description: fast paced 3D first person shooter
 Warsow is a fast paced first person shooter consisting of cel-shaded
 cartoon-like graphics with dark, flashy and dirty textures. Warsow is based on
 the E-novel "Chasseur de bots" ("Bots hunter" in English) by Fabrice Demurger.
 Warsow's codebase is built upon Qfusion, an advanced modification of the Quake
 II engine.
 .
 This package installs the client to play Warsow.

Package: warsow-dbg
Architecture: any
Priority: extra
Section: debug
Depends: ${misc:Depends},
         warsow (= ${binary:Version})
Description: fast paced 3D first person shooter (debug symbols)
 Warsow is a fast paced first person shooter consisting of cel-shaded
 cartoon-like graphics with dark, flashy and dirty textures. Warsow is based on
 the E-novel "Chasseur de bots" ("Bots hunter" in English) by Fabrice Demurger.
 Warsow's codebase is built upon Qfusion, an advanced modification of the Quake
 II engine.
 .
 This package contains the debugging symbols.

Package: warsow-server
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         warsow-data (>= 2.10)
Description: Server and TV server for the Warsow 3D first person shooter
 Warsow is a fast paced first person shooter consisting of cel-shaded
 cartoon-like graphics with dark, flashy and dirty textures. Warsow is based on
 the E-novel "Chasseur de bots" ("Bots hunter" in English) by Fabrice Demurger.
 Warsow's codebase is built upon Qfusion, an advanced modification of the Quake
 II engine.
 .
 This package installs the standalone server and TV server for Warsow.
